xref: /linux/scripts/kconfig/Makefile (revision 5f1201d515819e7cfaaac3f0a30ff7b556261386)
1# ===========================================================================
2# Kernel configuration targets
3# These targets are used from top-level makefile
4
5PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
6	localmodconfig localyesconfig
7
8ifdef KBUILD_KCONFIG
9Kconfig := $(KBUILD_KCONFIG)
10else
11Kconfig := Kconfig
12endif
13
14ifeq ($(quiet),silent_)
15silent := -s
16endif
17
18# We need this, in case the user has it in its environment
19unexport CONFIG_
20
21xconfig: $(obj)/qconf
22	$< $(silent) $(Kconfig)
23
24gconfig: $(obj)/gconf
25	$< $(silent) $(Kconfig)
26
27menuconfig: $(obj)/mconf
28	$< $(silent) $(Kconfig)
29
30config: $(obj)/conf
31	$< $(silent) --oldaskconfig $(Kconfig)
32
33nconfig: $(obj)/nconf
34	$< $(silent) $(Kconfig)
35
36silentoldconfig: $(obj)/conf
37	$(Q)mkdir -p include/config include/generated
38	$< $(silent) --$@ $(Kconfig)
39
40localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
41	$(Q)mkdir -p include/config include/generated
42	$(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
43	$(Q)if [ -f .config ]; then 					\
44			cmp -s .tmp.config .config ||			\
45			(mv -f .config .config.old.1;			\
46			 mv -f .tmp.config .config;			\
47			 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
48			 mv -f .config.old.1 .config.old)		\
49	else								\
50			mv -f .tmp.config .config;			\
51			$(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
52	fi
53	$(Q)rm -f .tmp.config
54
55# Create new linux.pot file
56# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
57update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
58	$(Q)$(kecho) "  GEN     config.pot"
59	$(Q)xgettext --default-domain=linux                         \
60	    --add-comments --keyword=_ --keyword=N_                 \
61	    --from-code=UTF-8                                       \
62	    --files-from=$(srctree)/scripts/kconfig/POTFILES.in     \
63	    --directory=$(srctree) --directory=$(objtree)           \
64	    --output $(obj)/config.pot
65	$(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
66	$(Q)(for i in `ls $(srctree)/arch/*/Kconfig      \
67	    $(srctree)/arch/*/um/Kconfig`;               \
68	    do                                           \
69		$(kecho) "  GEN     $$i";                    \
70		$(obj)/kxgettext $$i                     \
71		     >> $(obj)/config.pot;               \
72	    done )
73	$(Q)$(kecho) "  GEN     linux.pot"
74	$(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
75	    --output $(obj)/linux.pot
76	$(Q)rm -f $(obj)/config.pot
77
78# These targets map 1:1 to the commandline options of 'conf'
79simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
80	alldefconfig randconfig listnewconfig olddefconfig
81PHONY += $(simple-targets)
82
83$(simple-targets): $(obj)/conf
84	$< $(silent) --$@ $(Kconfig)
85
86PHONY += oldnoconfig savedefconfig defconfig
87
88# oldnoconfig is an alias of olddefconfig, because people already are dependent
89# on its behavior(sets new symbols to their default value but not 'n') with the
90# counter-intuitive name.
91oldnoconfig: olddefconfig
92
93savedefconfig: $(obj)/conf
94	$< $(silent) --$@=defconfig $(Kconfig)
95
96defconfig: $(obj)/conf
97ifeq ($(KBUILD_DEFCONFIG),)
98	$< $(silent) --defconfig $(Kconfig)
99else
100	@$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
101	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
102endif
103
104%_defconfig: $(obj)/conf
105	$(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
106
107configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
108
109%.config: $(obj)/conf
110	$(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
111	$(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
112	+$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
113
114PHONY += kvmconfig
115kvmconfig: kvm_guest.config
116	@:
117
118PHONY += xenconfig
119xenconfig: xen.config
120	@:
121
122PHONY += tinyconfig
123tinyconfig:
124	$(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
125
126# Help text used by make help
127help:
128	@echo  '  config	  - Update current config utilising a line-oriented program'
129	@echo  '  nconfig         - Update current config utilising a ncurses menu based program'
130	@echo  '  menuconfig	  - Update current config utilising a menu based program'
131	@echo  '  xconfig	  - Update current config utilising a QT based front-end'
132	@echo  '  gconfig	  - Update current config utilising a GTK based front-end'
133	@echo  '  oldconfig	  - Update current config utilising a provided .config as base'
134	@echo  '  localmodconfig  - Update current config disabling modules not loaded'
135	@echo  '  localyesconfig  - Update current config converting local mods to core'
136	@echo  '  silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
137	@echo  '  defconfig	  - New config with default from ARCH supplied defconfig'
138	@echo  '  savedefconfig   - Save current config as ./defconfig (minimal config)'
139	@echo  '  allnoconfig	  - New config where all options are answered with no'
140	@echo  '  allyesconfig	  - New config where all options are accepted with yes'
141	@echo  '  allmodconfig	  - New config selecting modules when possible'
142	@echo  '  alldefconfig    - New config with all symbols set to default'
143	@echo  '  randconfig	  - New config with random answer to all options'
144	@echo  '  listnewconfig   - List new options'
145	@echo  '  olddefconfig	  - Same as silentoldconfig but sets new symbols to their default value'
146	@echo  '  kvmconfig	  - Enable additional options for kvm guest kernel support'
147	@echo  '  xenconfig       - Enable additional options for xen dom0 and guest kernel support'
148	@echo  '  tinyconfig	  - Configure the tiniest possible kernel'
149
150# lxdialog stuff
151check-lxdialog  := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
152
153# Use recursively expanded variables so we do not call gcc unless
154# we really need to do so. (Do not call gcc as part of make mrproper)
155HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
156                    -DLOCALE
157
158# ===========================================================================
159# Shared Makefile for the various kconfig executables:
160# conf:	  Used for defconfig, oldconfig and related targets
161# nconf:  Used for the nconfig target.
162#         Utilizes ncurses
163# mconf:  Used for the menuconfig target
164#         Utilizes the lxdialog package
165# qconf:  Used for the xconfig target
166#         Based on QT which needs to be installed to compile it
167# gconf:  Used for the gconfig target
168#         Based on GTK which needs to be installed to compile it
169# object files used by all kconfig flavours
170
171lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
172lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
173
174conf-objs	:= conf.o  zconf.tab.o
175mconf-objs     := mconf.o zconf.tab.o $(lxdialog)
176nconf-objs     := nconf.o zconf.tab.o nconf.gui.o
177kxgettext-objs	:= kxgettext.o zconf.tab.o
178qconf-cxxobjs	:= qconf.o
179qconf-objs	:= zconf.tab.o
180gconf-objs	:= gconf.o zconf.tab.o
181
182hostprogs-y := conf nconf mconf kxgettext qconf gconf
183
184clean-files	:= qconf.moc .tmp_qtcheck .tmp_gtkcheck
185clean-files	+= zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
186clean-files     += config.pot linux.pot
187
188# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
189PHONY += $(obj)/dochecklxdialog
190$(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
191$(obj)/dochecklxdialog:
192	$(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
193
194always := dochecklxdialog
195
196# Add environment specific flags
197HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
198
199# generated files seem to need this to find local include files
200HOSTCFLAGS_zconf.lex.o	:= -I$(src)
201HOSTCFLAGS_zconf.tab.o	:= -I$(src)
202
203LEX_PREFIX_zconf	:= zconf
204YACC_PREFIX_zconf	:= zconf
205
206HOSTLOADLIBES_qconf	= $(KC_QT_LIBS)
207HOSTCXXFLAGS_qconf.o	= $(KC_QT_CFLAGS)
208
209HOSTLOADLIBES_gconf	= `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
210HOSTCFLAGS_gconf.o	= `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
211                          -Wno-missing-prototypes
212
213HOSTLOADLIBES_mconf   = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
214
215HOSTLOADLIBES_nconf	= $(shell \
216				pkg-config --libs menuw panelw ncursesw 2>/dev/null \
217				|| pkg-config --libs menu panel ncurses 2>/dev/null \
218				|| echo "-lmenu -lpanel -lncurses"  )
219$(obj)/qconf.o: $(obj)/.tmp_qtcheck
220
221ifeq ($(MAKECMDGOALS),xconfig)
222$(obj)/.tmp_qtcheck: $(src)/Makefile
223-include $(obj)/.tmp_qtcheck
224
225# QT needs some extra effort...
226$(obj)/.tmp_qtcheck:
227	@set -e; $(kecho) "  CHECK   qt"; dir=""; pkg=""; \
228	if ! pkg-config --exists QtCore 2> /dev/null; then \
229	    echo "* Unable to find the QT4 tool qmake. Trying to use QT3"; \
230	    pkg-config --exists qt 2> /dev/null && pkg=qt; \
231	    pkg-config --exists qt-mt 2> /dev/null && pkg=qt-mt; \
232	    if [ -n "$$pkg" ]; then \
233	      cflags="\$$(shell pkg-config $$pkg --cflags)"; \
234	      libs="\$$(shell pkg-config $$pkg --libs)"; \
235	      moc="\$$(shell pkg-config $$pkg --variable=prefix)/bin/moc"; \
236	      dir="$$(pkg-config $$pkg --variable=prefix)"; \
237	    else \
238	      for d in $$QTDIR /usr/share/qt* /usr/lib/qt*; do \
239	        if [ -f $$d/include/qconfig.h ]; then dir=$$d; break; fi; \
240	      done; \
241	      if [ -z "$$dir" ]; then \
242	        echo >&2 "*"; \
243	        echo >&2 "* Unable to find any QT installation. Please make sure that"; \
244	        echo >&2 "* the QT4 or QT3 development package is correctly installed and"; \
245	        echo >&2 "* either qmake can be found or install pkg-config or set"; \
246	        echo >&2 "* the QTDIR environment variable to the correct location."; \
247	        echo >&2 "*"; \
248	        false; \
249	      fi; \
250	      libpath=$$dir/lib; lib=qt; osdir=""; \
251	      $(HOSTCXX) -print-multi-os-directory > /dev/null 2>&1 && \
252	        osdir=x$$($(HOSTCXX) -print-multi-os-directory); \
253	      test -d $$libpath/$$osdir && libpath=$$libpath/$$osdir; \
254	      test -f $$libpath/libqt-mt.so && lib=qt-mt; \
255	      cflags="-I$$dir/include"; \
256	      libs="-L$$libpath -Wl,-rpath,$$libpath -l$$lib"; \
257	      moc="$$dir/bin/moc"; \
258	    fi; \
259	    if [ ! -x $$dir/bin/moc -a -x /usr/bin/moc ]; then \
260	      echo "*"; \
261	      echo "* Unable to find $$dir/bin/moc, using /usr/bin/moc instead."; \
262	      echo "*"; \
263	      moc="/usr/bin/moc"; \
264	    fi; \
265	else \
266	  cflags="\$$(shell pkg-config QtCore QtGui Qt3Support --cflags)"; \
267	  libs="\$$(shell pkg-config QtCore QtGui Qt3Support --libs)"; \
268	  moc="\$$(shell pkg-config QtCore --variable=moc_location)"; \
269	  [ -n "$$moc" ] || moc="\$$(shell pkg-config QtCore --variable=prefix)/bin/moc"; \
270	fi; \
271	echo "KC_QT_CFLAGS=$$cflags" > $@; \
272	echo "KC_QT_LIBS=$$libs" >> $@; \
273	echo "KC_QT_MOC=$$moc" >> $@
274endif
275
276$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
277
278ifeq ($(MAKECMDGOALS),gconfig)
279-include $(obj)/.tmp_gtkcheck
280
281# GTK needs some extra effort, too...
282$(obj)/.tmp_gtkcheck:
283	@if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then		\
284		if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then			\
285			touch $@;								\
286		else									\
287			echo >&2 "*"; 							\
288			echo >&2 "* GTK+ is present but version >= 2.0.0 is required.";	\
289			echo >&2 "*";							\
290			false;								\
291		fi									\
292	else										\
293		echo >&2 "*"; 								\
294		echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; 	\
295		echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; 	\
296		echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; 		\
297		echo >&2 "*"; 								\
298		false;									\
299	fi
300endif
301
302$(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
303
304$(obj)/qconf.o: $(obj)/qconf.moc
305
306quiet_cmd_moc = MOC     $@
307      cmd_moc = $(KC_QT_MOC) -i $< -o $@
308
309$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
310	$(call cmd,moc)
311
312# Extract gconf menu items for I18N support
313$(obj)/gconf.glade.h: $(obj)/gconf.glade
314	$(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
315	$(obj)/gconf.glade
316